﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module
Sub Class_Globals
	'Thread
	Private Th As Thread
	'True when thread Run. Put to False to stop thread.
	Private Th_Run As Boolean = False
	'Root name for events
	Private EvtRoot As String
	'Parent for calling event
	Private mEventObject As Object = Null
End Sub

'Initialize class
'EventRootName : Root name for events
Public Sub Initialize(EventRootName As String)
	Th.Initialise("Th")
	EvtRoot = EventRootName
End Sub

'Start Thread
'Return True if thread really start, Fales otherwise.
Public Sub ThStart As Boolean
	If Th_Run = False Then
		Dim args(0) As Object
		Th_Run = Th.Start(Me, "ThFunc", args)
	End If
	Return Th_Run
End Sub





























































'Arrete les mesures avec le sonometre
Public Sub ThStop 
	If Th.Running Then
		Th_Run = False
		Th.Join(0)
	End If
End Sub

'Methode that run in thread
Private Sub ThFunc
	Log("ThFunc is started")
	Th.RunOnGuiThread("SendEvt", Array As Object("ThStarted"))
	Do While Th_Run
		Th.Sleep(50)
	Loop
	
End Sub

'Set or return activities that receive event
Public Sub getEventObject As Object
	Return mEventObject
End Sub
Public Sub setEventObject(NewValue As Object)
	mEventObject = NewValue
End Sub

'Call when thread is finished
Private Sub Th_Ended(endedOk As Boolean, error As String)
	'Show error message if necessary
	If Not(endedOk) Then
		Dim CouleurLog As Int = Colors.Red
		LogColor("ThClass : Th Ended with error", CouleurLog)
		LogColor("Error : " & error, CouleurLog)
		Dim E As ExceptionEx = Th.Exception
		If Not(E.Message = Null) Then LogColor("Message : " & E.Message, CouleurLog)
		If Not(E.Cause = Null) Then
			Dim ExC As Exception = E.Cause
			LogColor("Cause : " & ExC.Message, CouleurLog)
		End If
		If Not(E.StackTrace = Null) Then LogColor("StackTrace : " & E.StackTrace, CouleurLog)
		'Msgbox(error, "AcqNano : SON_DataRcv Ended with error")
	End If
	'Send event to signal thread is finished
	'Th.RunOnGuiThread("SendEvt", Array As Object("ThFinished"))
	SendEvt("ThFinished")
	Log("Th ended")
End Sub

'Send event without parameter un evenement sans parametres
Private Sub SendEvt(EvtName As String)
	'Send event is something listen
	If mEventObject = Null Then Return
	If SubExists(mEventObject , EvtRoot & "_" & EvtName) Then CallSub(mEventObject, EvtRoot & "_" & EvtName)
End Sub
